//
//  AppleScriptFormatter.m
//  runtime test
//
//  Created by Takaaki Naganoya2 on 2025/01/06.
//

#import <Foundation/Foundation.h>

@interface AppleScriptFormatter : NSObject
	+ (NSString *)stringFromObject:(id)object;
@end

@implementation AppleScriptFormatter


+ (NSString *)stringFromObject:(id)object {
	if ([object isKindOfClass:[NSDictionary class]]) {
		NSMutableArray *elements = [NSMutableArray array];
		NSDictionary *dict = (NSDictionary *)object;
		for (id key in dict) {
			NSString *keyString = ([key isKindOfClass:[NSString class]]) ? key : [self stringFromObject:key];
			NSString *valueString = [self stringFromObject:dict[key]];
			[elements addObject:[NSString stringWithFormat:@"%@:%@", keyString, valueString]];
		}
		return [NSString stringWithFormat:@"{%@}", [elements componentsJoinedByString:@","]];
	} else if ([object isKindOfClass:[NSArray class]]) {
		NSMutableArray *elements = [NSMutableArray array];
		NSArray *array = (NSArray *)object;
		for (id element in array) {
			[elements addObject:[self stringFromObject:element]];
		}
		return [NSString stringWithFormat:@"{%@}", [elements componentsJoinedByString:@","]];
	} else if ([object isKindOfClass:[NSString class]]) {
		return [NSString stringWithFormat:@"\"%@\"", object];
	} else if ([object isKindOfClass:[NSNumber class]]) {
		return [object stringValue];
	} else if ([object isKindOfClass:[NSNull class]]) {
		return @"missing value";
	} else {
		return [NSString stringWithFormat:@"<%@>", NSStringFromClass([object class])];
	}
}

@end
