//
//  RuntimeUtils.m
//  runtime test
//
//  Created by Takaaki Naganoya2 on 2025/01/06.
//

#import "RuntimeUtils.h"
#import <objc/runtime.h>

@class NSObject;
@implementation RuntimeUtils
	

+(NSString *)getClassNameAndValue:(NSObject *)object {
	const char *className = NULL;
	
	Class class = [object class];
	if(class_isMetaClass(class)){
		className = class_getName(class);
	}else{
	className = class_getName(class_getSuperclass(class));
	}

	NSString *valueDescription = [object description];
	return [NSString stringWithFormat:@"(%s), %@", className, valueDescription];
}

+(NSString *)getClassName:(NSObject *)object {
	const char *className = NULL;
	
	Class class = [object class];
	if(class_isMetaClass(class)){
		className = class_getName(class);
	}else{
	className = class_getName(class_getSuperclass(class));
	}

	return [NSString stringWithFormat:@"(%s)", className];
}


@end
